#|

 Gtk ffi

 Copyright (c) 2004 by Vasilis Margioulas <vasilism@sch.gr>

 You have the right to distribute and use this software as governed by 
 the terms of the Lisp Lesser GNU Public License (LLGPL):

    (http://opensource.franz.com/preamble.html)
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 Lisp Lesser GNU Public License for more details.
 
|#

(in-package :gtk-ffi)


(def-gtk-lib-functions :gtk
  ;; main-loop
  (gtk-init ((argc (c-ptr-null int))
	     (argv c-pointer)))
  (gtk-init-check ((argc (c-ptr-null int))
		   (argv c-pointer))
    boolean)
  (gtk-events-pending ()
    boolean)
  (gtk-main-iteration ()
    boolean)
  (gtk-main-iteration-do ((blocking boolean))
    boolean nil nil)
  (gtk-main ())
  (gtk-main-quit ())
  (gtk-get-current-event-time ()
    uint32)

  ;;container
  (gtk-container-add ((container c-pointer)
		      (widget  c-pointer))
       c-pointer)
  (gtk-container-remove ((container c-pointer)
			 (widget c-pointer)))

  ;;box
  (gtk-box-pack-start ((box c-pointer)
		       (widget c-pointer)
		       (expand boolean)
		       (fill boolean)
		       (padding int))
    nil nil nil)
  (gtk-box-pack-start-defaults ((box c-pointer)
				(widget c-pointer)))
  (gtk-box-set-homogeneous ((box c-pointer)
			     (homogeneous boolean))
    nil nil nil)
  (gtk-box-set-spacing ((box c-pointer)
			(spacing int)))
  (gtk-hbox-new ((homogeneous boolean)
		 (spacing int))
    c-pointer nil nil)
  (gtk-vbox-new ((homogeneous boolean)
		 (spacing int))
    c-pointer nil nil)

  ;;table
  (gtk-table-new ((rows uint)
		  (columns uint)
		  (homogeneous boolean))
    c-pointer nil nil)
  (gtk-table-attach ((table c-pointer)
		     (child c-pointer)
		     (l-attach uint)
		     (r-attach uint)
		     (t-attach uint)
		     (b-attach uint)
		     (x-options int)
		     (y-options int)
		     (x-padding int)
		     (y-padding int)))
  (gtk-table-attach-defaults ((table c-pointer)
			      (child c-pointer)
			      (l-attach uint)
			      (r-attach uint)
			      (t-attach uint)
			      (b-attach uint)))
  (gtk-table-set-homogeneous ((table c-pointer)
			     (homogeneous boolean))
    nil nil nil)

  ;;paned
  (gtk-paned-add1 ((paned c-pointer)
		   (child c-pointer)))
  (gtk-paned-add2 ((paned c-pointer)
		   (child c-pointer)))
  (gtk-hpaned-new ()
    c-pointer)
  (gtk-vpaned-new ()
    c-pointer)

  ;;expander
  (gtk-expander-new ((label c-string))
    c-pointer)
  (gtk-expander-set-expanded ((expander c-pointer)
			      (expanded boolean)))
  (gtk-expander-set-spacing ((expander c-pointer)
			     (spacing c-pointer)))
  (gtk-expander-set-label ((expander c-pointer)
			   (label c-string)))
  (gtk-expander-set-use-underline ((expander c-pointer)
				   (use-underline boolean)))
  (gtk-expander-set-use-markup ((expander c-pointer)
				(use-markup boolean)))
  (gtk-expander-set-label-widget ((expander c-pointer)
				  (label-widget c-pointer)))

  ;;alignment 
  (gtk-alignment-new ((xalign single-float)
		      (yalign single-float)
		      (xscale single-float)
		      (yscale single-float))
    c-pointer)
  (gtk-alignment-set ((alignment c-pointer)
		      (xalign single-float)
		      (yalign single-float)
		      (xscale single-float)
		      (yscale single-float)))
  
  ;;frame
  (gtk-frame-new ((label c-string))
    c-pointer)
  (gtk-frame-set-label ((frame c-pointer)
			(label c-string)))
  (gtk-frame-set-label-widget ((frame c-pointer)
			 (label-widget c-pointer)))
  (gtk-frame-set-label-align ((frame c-pointer)
			      (xalign single-float)
			      (yalign single-float)))
  (gtk-frame-set-shadow-type ((frame c-pointer)
			      (shadow-type int)))
  
  ;;aspect-frame
  (gtk-aspect-frame-new ((label c-string)
			 (xalign single-float)
			 (yalign single-float)
			 (ratio single-float)
			 (obey_child boolean))
    c-pointer)

  ;;separator
  (gtk-hseparator-new ()
    c-pointer)
  (gtk-vseparator-new ()
    c-pointer)

  ;;scrolling
  (gtk-scrolled-window-new ((hadjustment c-pointer)
			    (vadjustment c-pointer))
    c-pointer)
  (gtk-scrolled-window-set-policy ((scrolled-window c-pointer)
				   (h-policy int)
				   (v-policy int)))
  (gtk-scrolled-window-add-with-viewport ((scrolled-window c-pointer)
					  (child c-pointer)))
  (gtk-scrolled-window-set-placement ((scrolled-window c-pointer)
				      (placement int)))
  (gtk-scrolled-window-set-shadow-type ((scrolled-window c-pointer)
					(type int)))

  ;;notebook 
  (gtk-notebook-new ()
    c-pointer)
  (gtk-notebook-append-page ((notebook c-pointer)
			     (child c-pointer)
			     (tab-label c-pointer))
    int)
  (gtk-notebook-append-page-menu ((notebook c-pointer)
				  (child c-pointer)
				  (tab-label c-pointer)
				  (menu-label c-pointer))
    int)
  (gtk-notebook-prepend-page ((notebook c-pointer)
			     (child c-pointer)
			     (tab-label c-pointer))
    int)
  (gtk-notebook-prepend-page-menu ((notebook c-pointer)
				  (child c-pointer)
				  (tab-label c-pointer)
				  (menu-label c-pointer))
    int)
  (gtk-notebook-insert-page ((notebook c-pointer)
			     (child c-pointer)
			     (tab-label c-pointer)
			     (pos int))
    int)
  (gtk-notebook-insert-page-menu ((notebook c-pointer)
				  (child c-pointer)
				  (tab-label c-pointer)
				  (menu-label c-pointer)
				  (pos int))
    int)
  (gtk-notebook-remove-page ((notebook c-pointer)
			     (page-num int)))
  (gtk-notebook-set-current-page ((notebook c-pointer)
				  (page-num int)))
  (gtk-notebook-set-tab-pos ((notebook c-pointer)
			     (pos int)))
  (gtk-notebook-set-show-tabs ((notebook c-pointer)
			       (show-tabs boolean)))
  (gtk-notebook-set-show-border ((notebook c-pointer)
				 (show-border boolean)))
  (gtk-notebook-set-scrollable ((notebook c-pointer)
			       (scrollable boolean)))
  (gtk-notebook-set-tab-border ((notebook c-pointer)
				(border-width int)))
  (gtk-notebook-popup-enable ((notebook c-pointer)))
  (gtk-notebook-popup-disable ((notebook c-pointer)))
  (gtk-notebook-set-homogeneous-tabs ((notebook c-pointer)
				      (homogeneous-tabs boolean)))

  ;;label
  (gtk-label-new ((text c-string))
    c-pointer)
  (gtk-label-set-text ((label c-pointer)
		       (text c-string)))
  (gtk-label-set-text-with-mnemonic ((label c-pointer)
				     (text c-string)))
  (gtk-label-set-line-wrap ((label c-pointer)
			    (wrap boolean)))
  (gtk-label-set-selectable ((label c-pointer)
			     (selectable boolean)))
  (gtk-label-set-use-markup ((label c-pointer)
			     (use-markup boolean)))
  (gtk-label-set-markup ((label c-pointer)
			 (markup c-string)))
  (gtk-label-set-markup-with-mnemonic ((label c-pointer)
				       (markup c-string)))

  (gtk-accel-label-new ((str c-string))
    c-pointer)
  (gtk-accel-label-set-accel-widget ((label c-pointer)
				     (widget c-pointer)))

  ;;progress
  (gtk-progress-bar-new ()
    c-pointer)
  (gtk-progress-bar-pulse ((pbar c-pointer)))
  (gtk-progress-bar-set-text ((pbar c-pointer)
			      (text c-string)))
  (gtk-progress-bar-set-fraction ((pbar c-pointer)
				  (fraction double-float)))
  (gtk-progress-bar-set-pulse-step ((pbar c-pointer)
				    (fraction double-float)))
  (gtk-progress-bar-set-orientation ((pbar c-pointer)
				     (orientation int)))				    
  (gtk-progress-bar-set-bar-style ((pbar c-pointer)
				   (style int)))
  (gtk-progress-bar-set-discrete-blocks ((pbar c-pointer)
					 (blocks uint)))
  (gtk-progress-bar-set-activity-step ((pbar c-pointer)
				       (step uint)))
  (gtk-progress-bar-set-activity-blocks ((pbar c-pointer)
					 (blocks uint)))
  (gtk-progress-bar-update ((pbar c-pointer)
			    (percentage double-float)))

  ;;image 
  (gtk-image-new-from-file ((filename c-string))
    c-pointer)
  (gtk-image-new-from-stock ((stock c-string)
			     (icon-size int))
    c-pointer)
  (gtk-image-set-from-stock ((image c-pointer)
			     (stock c-string)
			     (icon-size int)))
  (gtk-image-get-pixbuf ((image c-pointer))
    c-pointer)

  ;;icon-factory
  (gtk-icon-factory-new ()
    c-pointer)
  (gtk-icon-factory-add-default ((factory c-pointer)))
  (gtk-icon-factory-add ((factory c-pointer)
                         (stock-id c-string)
                         (icon-set c-pointer)))

  ;;icon-set
  (gtk-icon-set-new-from-pixbuf ((pixbuf c-pointer))
    c-pointer)                            

  ;;statusbar
  (gtk-statusbar-new ()
    c-pointer)
  (gtk-statusbar-get-context-id ((sbar c-pointer)
				 (description c-string))
     uint)
  (gtk-statusbar-push ((sbar c-pointer)
		       (context-id uint)
		       (text c-string))
    uint)
  (gtk-statusbar-pop ((sbar c-pointer)
		      (context-id uint)))
  (gtk-statusbar-remove ((sbar c-pointer)
			 (context-id uint)
			 (message-id uint)))
  (gtk-statusbar-set-has-resize-grip ((sbar c-pointer)
				      (setting boolean))
    nil nil nil)
 
  ;;widget
  (gtk-widget-show ((widget c-pointer)))
  (gtk-widget-show-all ((widget c-pointer)))
  (gtk-widget-hide ((widget c-pointer)))
  (gtk-widget-destroy ((widget c-pointer)))
  (gtk-widget-set-sensitive ((widget c-pointer)
			     (sensitive boolean))
    nil nil nil)
  (gtk-widget-set-size-request ((widget c-pointer)
				(width int)
				(height int)))
  (gtk-widget-get-parent-window ((widget c-pointer))
    c-pointer)
  (gtk-widget-add-accelerator ((widget c-pointer)
			       (gsignal c-string)
			       (accel-group c-pointer)
			       (key uint)
			       (mods int)
			       (flags int)))
  (gtk-widget-grab-focus ((widget c-pointer)))
  (gtk-widget-add-events ((widget c-pointer)
                          (events int)))
  (gtk-widget-set-events ((widget c-pointer)
                          (events int)))
  (gtk-widget-get-events ((widget c-pointer))
     int)

  ;;window
  (gtk-window-new ((type int))
       c-pointer)  
  (gtk-window-set-title ((widget c-pointer)
			 (title c-string)))
  (gtk-window-set-icon-from-file ((window c-pointer)
				  (filename c-string)
				  (err c-pointer))
    boolean)
  (gtk-window-set-default-size ((widget c-pointer)
				(width int)
				(height int)))
  (gtk-window-set-resizable ((widget c-pointer)
			     (resizable boolean)))
  (gtk-window-set-decorated ((widget c-pointer)
			     (decorated boolean))
    nil nil nil)
  (gtk-window-set-auto-startup-notification ((setting boolean)) nil nil nil)
  (gtk-window-set-position ((widget c-pointer)
			    (position int)))
  (gtk-window-maximize ((widget c-pointer)))
  (gtk-window-unmaximize ((widget c-pointer)))
  (gtk-window-iconify ((widget c-pointer)))
  (gtk-window-deiconify ((widget c-pointer)))
  (gtk-window-fullscreen ((widget c-pointer)))
  (gtk-window-unfullscreen ((widget c-pointer)))
  (gtk-window-add-accel-group ((window c-pointer)
			       (accel-group c-pointer)))

  ;;entry
  (gtk-entry-new ()
     c-pointer)
  (gtk-entry-set-text ((entry c-pointer)
		       (text c-string)))
  (gtk-entry-get-text ((entry c-pointer))
     c-pointer)
  (gtk-entry-set-max-length ((entry c-pointer)
			     (max-length int)))
  (gtk-entry-set-editable ((entry c-pointer)
			   (editable boolean)))
  (gtk-entry-set-completion ((entry c-pointer)
			     (completion c-pointer)))
  (gtk-entry-set-has-frame ((entry c-pointer)
			    (has-frame boolean)))

  ;;entry-completion
  (gtk-entry-completion-new ()
    c-pointer)
  (gtk-entry-completion-set-model ((completion c-pointer)
				   (model c-pointer)))
  (gtk-entry-completion-set-text-column ((completion c-pointer)
					 (column int)))

  ;;range
  (gtk-range-set-range ((range c-pointer)
			(minval double-float)
			(maxval double-float)))
  (gtk-range-set-value ((range c-pointer)
			(val double-float)))
  (gtk-range-set-inverted ((range c-pointer)
			   (inverted boolean)))
  (gtk-range-set-increments ((range c-pointer)
			     (step double-float)
			     (page double-float)))
  (gtk-range-set-update-policy ((range c-pointer)
				(policy int)))
  (gtk-range-get-value ((range c-pointer))
     double-float)

 ;;scale
  (gtk-scale-set-draw-value ((scale c-pointer)
			     (draw-value boolean)))
  (gtk-scale-set-value-pos ((scale c-pointer)
			    (pos-type int)))
  (gtk-scale-set-digits ((scale c-pointer)
			 (digits int)))

 ;;hscale
  (gtk-hscale-new ((adjustment c-pointer))
    c-pointer)
  (gtk-hscale-new-with-range ((minval double-float)
			      (maxval double-float)
			      (step double-float))
    c-pointer)

  ;;vscale
  (gtk-vscale-new ((adjustment c-pointer))
    c-pointer)
  (gtk-vscale-new-with-range ((minval double-float)
			      (maxval double-float)
			      (step double-float))
    c-pointer)
  
  ;;combo-box
  (gtk-combo-box-new-text ()
    c-pointer)
  (gtk-combo-box-append-text ((combo-box c-pointer)
			      (text c-string)))
  (gtk-combo-box-remove-text ((combo-box c-pointer)
			      (position int)))
  (gtk-combo-box-set-active ((combo-box c-pointer)
			     (index int)))
  (gtk-combo-box-get-active ((combo-box c-pointer))
    int)

  ;;calendar
  (gtk-calendar-new ()
    c-pointer)
  (gtk-calendar-get-date ((cal c-pointer)
			  (year c-pointer)
			  (month c-pointer)
			  (day c-pointer)))
  (gtk-calendar-select-month ((cal c-pointer)
			      (month uint)
			      (year uint))
    int)
  (gtk-calendar-select-day ((cal c-pointer)
			    (day uint)))

  ;;arrow
  (gtk-arrow-new ((arrow-type int)
		  (shadow-type int))
    c-pointer)
  (gtk-arrow-set ((arrow c-pointer)
		  (arrow-type int)
		  (shadow-type int)))

  ;;dialog
  (gtk-dialog-new ()
    c-pointer)
  (gtk-dialog-run ((dialog c-pointer))
    int)
  (gtk-dialog-response ((dialog c-pointer)
			(response-id int)))
  (gtk-dialog-add-button ((dialog c-pointer)
			  (button-text c-string)
			  (response-id int))
    c-pointer)
  (gtk-dialog-add-action-widget ((dialog c-pointer)
				 (child c-pointer)
				 (response-id c-pointer)))
  (gtk-dialog-set-has-separator ((dialog c-pointer)
				 (has-separator boolean)))
  (gtk-dialog-set-default-response ((dialog c-pointer)
				    (response-id int)))
  ;;message-dialog
  (gtk-message-dialog-new ((parent c-pointer)
			   (flags int)
			   (type int)
			   (buttons int)
			   (message c-string))
    c-pointer)
  (gtk-message-dialog-set-markup ((dialog c-pointer)
				  (str c-string)))
  ;;file-chooser
  (gtk-file-chooser-set-action ((chooser c-pointer)
				(action int)))
  (gtk-file-chooser-set-local-only ((chooser c-pointer)
				    (local-only boolean)))
  (gtk-file-chooser-set-select-multiple ((chooser c-pointer)
					 (select-multiple boolean)))
  (gtk-file-chooser-set-current-name ((chooser c-pointer)
				      (name c-string)))
  (gtk-file-chooser-set-filename ((chooser c-pointer)
				  (filename c-string))
    boolean)
  (gtk-file-chooser-get-filename ((chooser c-pointer))
    c-string :malloc-free)
  (gtk-file-chooser-get-filenames ((chooser c-pointer))
    c-pointer)
  (gtk-file-chooser-set-current-folder ((chooser c-pointer)
					(folder c-string))
    boolean)
  (gtk-file-chooser-get-current-folder ((chooser c-pointer))
    c-string :malloc-free)
  (gtk-file-chooser-set-uri ((chooser c-pointer)
			     (uri c-string))
    boolean)
  (gtk-file-chooser-get-uri ((chooser c-pointer))
    c-string :malloc-free)
  (gtk-file-chooser-select-uri ((chooser c-pointer))
    boolean)
  (gtk-file-chooser-get-uris ((chooser c-pointer))
    c-pointer)
  (gtk-file-chooser-set-current-folder-uri ((chooser c-pointer)
					    (folder c-string))
    boolean)
  (gtk-file-chooser-get-current-folder-uri ((chooser c-pointer))
    c-string :malloc-free)
  (gtk-file-chooser-set-use-preview-label ((chooser c-pointer)
					   (use-label boolean)))
  (gtk-file-chooser-add-filter ((chooser c-pointer)
				(filter c-pointer)))
  (gtk-file-chooser-set-filter ((chooser c-pointer)
				(filter c-pointer)))
  ;;file-chooser-widget
  (gtk-file-chooser-widget-new ((action int))
    c-pointer)
  ;;file-chooser-dialog
  (gtk-file-chooser-dialog-new ((title c-string)
				(parent c-pointer)
				(action int)
				(cancel-text c-string)
				(cancel-response-id int)
				(accept-text c-string)
				(accept-response-id int)
				(null c-pointer))
    c-pointer)
  
    ;;file-filter
  (gtk-file-filter-new ()
    c-pointer)
  (gtk-file-filter-set-name ((filter c-pointer)
			     (name c-string)))
  (gtk-file-filter-add-mime-type ((filter c-pointer)
				  (mime-type c-string)))
  (gtk-file-filter-add-pattern ((filter c-pointer)
				(pattern c-string)))

  ;;text-view
  (gtk-text-view-new ()
    c-pointer)
  (gtk-text-view-set-buffer ((text-view c-pointer)
			     (buffer c-pointer)))
  
  ;;text-buffer
  (gtk-text-buffer-new ((table c-pointer))
    c-pointer)
  (gtk-text-buffer-set-text ((buffer c-pointer)
			     (text c-string)
			     (len int)))

  ;;text-tag-table
  (gtk-text-tag-table-new ()
    c-pointer)
 
  ;;accel-group
  (gtk-accel-group-new ()
    c-pointer)

  ;;ui-manager
  (gtk-ui-manager-new ()
    c-pointer)
  (gtk-ui-manager-set-add-tearoffs ((ui-manager c-pointer)
				    (add-tearoffs boolean)))
  (gtk-ui-manager-insert-action-group ((ui-manager c-pointer)
				       (action-group c-pointer)
				       (pos int)))
  (gtk-ui-manager-get-toplevels ((ui-manager c-pointer)
				 (types int))
    c-pointer)

  ;;action-group
  (gtk-action-group-new ((name c-string))
    c-pointer)
  (gtk-action-group-set-sensitive ((action-group c-pointer)
				   (sensitive boolean)))
  (gtk-action-group-set-visible ((action-group c-pointer)
				 (visible boolean)))
  (gtk-action-group-add-action ((action-group c-pointer)
				(action c-pointer)))
  (gtk-action-group-remove-action ((action-group c-pointer)
				   (action c-pointer)))
  (gtk-action-group-add-action-with-accel ((action-group c-pointer)
					   (action c-pointer)
					   (accel c-string)))
  ;;action
  (gtk-action-new ((name c-string)
		   (label c-pointer)
		   (tooltip c-pointer)
		   (stock-id c-string))
    c-pointer)

  (gtk-event-box-new ()
    c-pointer)
  (gtk-event-box-set-above-child ((event-box c-pointer)
				  (above boolean)))
  (gtk-event-box-set-visible-window ((event-box c-pointer)
				     (visible-window boolean))
    nil nil nil)
  
  ;; miscellaneous
  (gtk-check-version ((required-major uint)
                      (required-minor uint)
                      (required-micro uint))
    c-string))

#+libcellsgtk
(def-gtk-lib-functions :cgtk
    (gtk-adds-dialog-vbox 
     ((dialog c-pointer))
     c-pointer)
  (gtk-adds-text-view-popup-menu
   ((treeview c-pointer))
   c-pointer))

(defmacro you-need-libcellsgtk (&body names)
  `(progn
     ,@(loop for name in names
          collect `(defun ,name (&rest ignore) 
                     (declare (ignore ignore))
                     (error "You need libcellsgtk.so to use function ~A." ',name)))))

#-libcellsgtk
(you-need-libcellsgtk
 gtk-adds-dialog-box
 gtk-adds-text-view-popup-menu)
 


                      